; #############################################################################
; #############################################################################
; #############################################################################
; Puffer mit DATENBYTES laden, wird per "PAKET_SENDEN" zum Display gesendet		
;																				
;	inp: temp																	
;																				
PAKET_DATA_TEMP:
	; Sicherungskopie	
	push ZL
	push ZH
	push temp
	push temp1
	; Z-ZEIGER			
	ldi ZL,LOW (adr_GRAFIC_PUFFER256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER256)
	; addieren			
	LDS temp1,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	add ZL,temp1
	adc ZH,NULL
	; speichern nach Z	
	ST Z,temp
	; Zeiger speichern	
	inc temp1
	STS(adr_GRAFIC_PUFFER_TX_ZEIGER),temp1
	; Puffer zu voll ?	
	cpi temp1,(PUFFER_DISPLAY_MAX)
	brne PAKET_DATA_FERTIG
	; sofort leeren						
	rcall PAKET_SENDEN
PAKET_DATA_FERTIG:
	; wiederherstellen (sicherungskopie)
	pop temp1
	pop temp
	pop ZH
	pop ZL
ret
; #############################################################################
; #############################################################################
; #############################################################################
; komplettes Paket zum Display senden 											
;																				
; <DC1> <LEN> <DATA> <PS>														
;																				
; temp = Hilfsregister															
; temp1= Hilfsregister															
; temp8= Zeiger																	
; temp9= Prfsumme (PS)															
; ZL   = ZEIGER																	
; ZH   = ZEIGER																	
PAKET_SENDEN:
	; Daten vorhanden ? len = NULL ?
	LDS temp,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	tst temp
	brne PAKET_SENDEN_RUN
	ret
;-----------------------------------------------------------------------------
PAKET_SENDEN_RUN:
	; sichern				
	push temp
	push temp1	; Hilfsregister	
	push temp2
	push temp3
	push temp4
	push temp5
	push temp6
	push temp7
	push temp8	; Schleife
	push temp9	; Hilfsregister	
	push ZL
	push ZH
;-----------------------------------------------------------------------------
PAKET_SENDEN_S:
	; TWI START				
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	WDR
	; <DC1>				
	ldi temp1,17			
	mov temp9,temp1						; PS				
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	; len				
	LDS temp1,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	add temp9,temp1						; PS				
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	; Intialisierung	
	LDS temp8,(adr_GRAFIC_PUFFER_TX_ZEIGER)
	ldi ZL,LOW (adr_GRAFIC_PUFFER256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER256)
;-----------------------------------------------------------------------------
PAKET_SENDEN_D:
	LD temp1,Z+							; DATA	
	add temp9,temp1						; PS	
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	dec temp8
	brne PAKET_SENDEN_D
	; BCC (PRFSUMME)	
	mov temp1,temp9						; PS
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall PAKET_ANTWORT_TEMP1
	cpi temp1,6
	breq PAKET_SENDEN_OK
;-----------------------------------------------------------------------------
	; ERROR				
	ldi temp,(ERROR_GRAFIC_TX)
	rcall ERROR_SPEICHERN_TEMP	
	rjmp PAKET_SENDEN_S						; nochmal senden
;-----------------------------------------------------------------------------
PAKET_SENDEN_OK:
	; NULL				
	STS(adr_GRAFIC_PUFFER_TX_ZEIGER),NULL
	; wieder herstellen	
	pop ZH
	pop ZL
	pop temp9
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp4
	pop temp3
	pop temp2
	pop temp1
	pop temp
	ret
; #############################################################################
; #############################################################################
; #############################################################################
; Inhalt DISPLAY-SENDEPUFFER anfordern											
; OUT: temp1(ANZAHL BYTES)+SRAM													
;																				
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_TEMP1_SRAM:
	; PUFFER leeren		
	rcall PAKET_SENDEN
;-----------------------------------------------------------------------------
	; SRAM clear		
	STS(adr_GRAFIC_PUFFER256+0),NULL
	STS(adr_GRAFIC_PUFFER256+1),NULL
	STS(adr_GRAFIC_PUFFER256+2),NULL
	STS(adr_GRAFIC_PUFFER256+3),NULL
	; START				
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	; <DC2>				
	ldi temp1,18			
	mov temp9,temp1			; PS
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	; len				
	ldi temp1,1
	add temp9,temp1			; PS
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	; DATA				
	ldi temp1,'S'
	add temp9,temp1			; PS
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	; BCC (PRFSUMME)	
	mov temp1,temp9
	rcall TWI_MASTER_TRANSMITTER_TEMP1
	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall PAKET_ANTWORT_TEMP1
	cpi temp1,6
	breq PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_OK
;-----------------------------------------------------------------------------
	; ERROR				
	ldi temp,(ERROR_GRAFIC_RX)
	rcall ERROR_SPEICHERN_TEMP	
	rjmp PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_TEMP1_SRAM
;-----------------------------------------------------------------------------
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_OK:
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	rcall TWI_MASTER_RECEIVER_START_TEMP1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1	; <DC1>
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1	; <len>
	push temp1
	tst temp1
	breq PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_ENDE
	; Schleife		
	mov temp9,temp1
	; Z-ZEIGER		
	ldi ZL,LOW (adr_GRAFIC_PUFFER256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER256)
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_S:
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1
	; im SRAM ablegen	
	ST Z+,temp1
	dec temp9
	brne PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_S
;-----------------------------------------------------------------------------
PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_ENDE:
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1	; PS
	rcall TWI_STOP
	pop temp1									; Anzahl Bytes	
ret
; #############################################################################
; #############################################################################
; #############################################################################
; Antwortbyte vom DISPLAY anfordern												
;																				
; OUT: temp1																	
;																			 	
PAKET_ANTWORT_TEMP1:
	; START				
	ldi temp1,(TWI_ADRESSE_DISPLAY)
	rcall TWI_MASTER_RECEIVER_START_TEMP1
	; DATENBYTE abholen	
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1
	; STOPP				
	rjmp TWI_STOP
; #############################################################################
; #############################################################################
; #############################################################################
