;												
; RADIO SI4735 AM/FM/RDS fr ATmega8			
; Bernhard.Erfurt@gmx.de						
; 08/2013										
;												
; DISPLAY EA-EDIP160W-7LWTP						
; 13x20 (160x104)								
;												
; LW/AM	(153279 KHz)							
; MW/AM	(5201710 kHz)							
; KW/AM	(2.321.85 MHz)							
; UKW/FM(64108 MHz)							
;												
; AVR-Studio 4									
;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> PWM (Analoginstrument)				
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> (Quarz)								
; PB7 ==> (Quarz)								
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> TWI-SDA (grn)						
; PC5 ==> TWI-SCL (gelb)						
;												
; PD0 ==> 										
; PD1 ==> RS232 (OUT)							
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												

; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT							=1000000	; 1 MHz	
; BAUD											
.equ BAUD							=4800
; TWI SLAVE (SI4735)							
.equ TWI_ADRESSE_RADIO				= 17
.equ TWI_ADRESSE_DISPLAY			= 111 		;(Anzeige im DISPLAY: 0xDE)
; TWI MASTER EINSTELLUNGEN						
.equ TWI_BIT_RATE					= 100		; 255	; Bit-Rate							
.equ TWI_PRESCALER					= 0			; 1		; Vorteiler: 0=1 1=4 2=16 3=64		
; DISPLAY_PUFFER								
.equ PUFFER_DISPLAY_MAX				= 60		; s. Datenblatt
; EEPROM LSCHBYTE								
.equ EEPROM_LOESCHBYTE				= '?'		; fr Werkseinstellung bzw. 1.Programmstart	
; LAUTSTRKEN RX_VOLUME	(0...63 				
.equ LAUTSTAERKE_PROGRAMMSTART		=40
.equ LAUTSTAERKE_ANHEBUNG_TA		=10	 		; Anhebung 	(Verkehrsdurchsage)		
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; PWM-AUSGANG (Analoginstrument)				
.equ PWM_PIN_NR						= 1
.equ PWM_DDR						= DDRB
.equ PWM_PORT						= PORTB
; MODUI											
.equ MODUS_AUS						= 0
.equ MODUS_LW						= 1
.equ MODUS_MW						= 2
.equ MODUS_KW						= 3
.equ MODUS_UKW						= 4

; FEHLER-CODES									
.equ ERROR_GRAFIC_TX				= 6		; Verbindungsfehler		
.equ ERROR_GRAFIC_RX				= 8

.equ ERROR_TWI_MT_START				= 10
.equ ERROR_TWI_MT_SLA				= 12
.equ ERROR_TWI_MT_DATA				= 14

.equ ERROR_TWI_MR_START				= 20
.equ ERROR_TWI_MR_SLA				= 21
.equ ERROR_TWI_MR_DATA				= 22
.equ ERROR_TWI_MR_DATAEND			= 23
; FEHLER-CODES									
.equ ERROR_INT_STATUS				= 60
; STATUS-BITS									
.equ STATUS_BIT_CTS 				=128
.equ STATUS_BIT_ERR  				=64
.equ STATUS_BIT_RSQINT 				=8
.equ STATUS_BIT_RDSINT				=4  
.equ STATUS_BIT_STCINT				=1
; Rev. 1.0 4/08 Table 14. Si473x Command												
.equ POWER_UP			= 0x01 ; Power up device and mode selection. 			
.equ GET_REV			= 0x10 ;  Returns revision information on the device.	
.equ POWER_DOWN			= 0x11 ;  Power down device.							
.equ SET_PROPERTY		= 0x12 ;  Sets the value of a property.					
.equ GET_PROPERTY		= 0x13 ;  Retrieves a propertys value.					
.equ GET_INT_STATUS		= 0x14 ;  Read interrupt status bits.					
.equ PATCH_ARGS			= 0x15 ;  Reserved command used for firmware file downloads.
.equ PATCH_DATA			= 0x16 ;  Reserved command used for firmware file downloads.
.equ FM_TUNE_FREQ		= 0x20 ;  Selects the FM tuning frequency.				
.equ FM_SEEK_START		= 0x21 ;  Begins searching for a valid frequency		
.equ FM_TUNE_STATUS		= 0x22 ;  Queries the status of previous FM_TUNE_FREQ or FM_SEEK_START command.
.equ FM_RSQ_STATUS		= 0x23 ;  Queries the status of the Received Signal Quality (RSQ) of the current channel (Si4735 only).
.equ FM_RDS_STATUS		= 0x24 ;  Returns RDS information for current channel and reads an entry from theRDS FIFO (Si4735 only).
.equ AM_TUNE_FREQ		= 0x40 ;  Tunes to a given AM or SW/LW frequency.		
.equ AM_SEEK_START		= 0x41 ;  Begins searching for a valid AM or SW/LW frequency depending on the AM_SEEK_BAND_BOTTOM and AM_SEEK_BAND_TOP settings.
.equ AM_TUNE_STATUS		= 0x42 ;  Queries the status of the already issued AM_TUNE_FREQ or AM_SEEK_START command.
.equ AM_RSQ_STATUS		= 0x43 ;  Queries the status of the RSQ for the current channel.
.equ GPO_CTL			= 0x80 ;  Configures GPO pins.							
.equ GPO_SET			= 0x81 ;  Sets the value of the GPO pins.				

; Rev. 1.0 4/08 Table 15. Si473x Property												
.equ GPO_IEN						= 0x0001 ; Enables interrupt sources. 0x0000
.equ DIGITAL_OUTPUT_FORMAT			= 0x0102 ; Configures the digital output format (Si4735 only). 0x0000
.equ DIGITAL_OUTPUT_SAMPLE_RATE		= 0x0104 ; Configures the digital output sample rate in 100 Hz steps. The digital output sample rate is disabled by default (Si4735 only). 0x0000
.equ REFCLK_FREQ 					= 0x0201 ; Sets frequency of reference clock in Hz. The range is 31130 to 34406 Hz, or 0 to disable the AFC. Default is 32768 Hz. 0x8000
.equ REFCLK_PRESCALE				= 0x0202 ; Sets the prescaler value for RCLK input. 0x0001
.equ FM_DEEMPHASIS					= 0x1100 ; Sets de-emphasis time constant. Default is 75 us. 0x0002
.equ FM_BLEND_STEREO_THRESHOLD 		= 0x1105 ; Sets RSSI threshold for stereo blend (full stereo above threshold,blend below threshold). To force stereo set this to 0. To force mono set this to 127. Default value is 49 dBuV. 0x0031
.equ FM_BLEND_MONO_THRESHOLD		= 0x1106 ; Sets RSSI threshold for mono blend (full mono below threshold, blend above threshold). To force stereo set this to 0. To force mono set this to 127. Default value is 30 dBuV.0x001E 
.equ FM_MAX_TUNE_ERROR 				= 0x1108 ; Sets the maximum freq error allowed before setting the AFC rail (AFCRL) indicator. Default value is 30 kHz. 0x001E 
.equ FM_RSQ_INT_SOURCE 				= 0x1200 ; Configures interrupt related to RSQ metrics. 0x0000
.equ FM_RSQ_SNR_HI_THRESHOLD		= 0x1201 ; Sets high threshold for SNR interrupt. 0x007F
.equ FM_RSQ_SNR_LO_THRESHOLD		= 0x1202 ; Sets low threshold for SNR interrupt. 0x0000
.equ FM_RSQ_RSSI_HI_THRESHOLD		= 0x1203 ; Sets high threshold for RSSI interrupt. 0x007F
.equ FM_RSQ_RSSI_LO_THRESHOLD		= 0x1204 ; Sets low threshold for RSSI interrupt. 0x0000
.equ FM_RSQ_BLEND_THRESHOLD			= 0x1207 ; Sets the blend threshold for blend interrupt when boundary is crossed. 0x0081 
.equ FM_SOFT_MUTE_MAX_ATTENUATION	= 0x1302 ; Sets maximum attenuation during soft mute (dB). Set to 0 to disable soft mute. Default is 16 dB. 0x0010
.equ FM_SOFT_MUTE_SNR_THRESHOLD 	= 0x1303 ; Sets SNR threshold to engage soft mute. Default is 4 dB. 0x0004
.equ FM_SEEK_BAND_BOTTOM			= 0x1400 ; Sets the bottom of the FM band for seek. Default is 8750. 0x222E
.equ FM_SEEK_BAND_TOP 				= 0x1401 ; Sets the top of the FM band for seek. Default is 10790. 0x2A26
.equ FM_SEEK_FREQ_SPACING			= 0x1402 ; Selects frequency spacing for FM seek. 0x000A
.equ FM_SEEK_TUNE_SNR_THRESHOLD		= 0x1403 ; Sets the SNR threshold for a valid FM Seek/Tune. Default value is 3 dB. 0x0003
.equ FM_SEEK_TUNE_RSSI_THRESHOLD	= 0x1404 ; Sets the RSSI threshold for a valid FM Seek/Tune. Default value is 20 dBuV. 0x0014
.equ FM_RDS_INT_SOURCE				= 0x1500 ; Configures RDS interrupt behavior. 0x0000
.equ FM_RDS_INT_FIFO_COUNT			= 0x1501 ; Sets the minimum number of RDS groups stored in the receive RDS FIFO required before RDS RECV is set. 0x0000
.equ FM_RDS_CONFIG 					= 0x1502 ; Configures RDS setting. 0x0000
.equ FM_BLEND_RSSI_STEREO_THRESHOLD	= 0x1800 ; Sets RSSI threshold for stereo blend. (Full stereo above threshold, blend below threshold.) To force stereo, set this to 0. To force mono, set this to 127. Default value is 49 dBV. (0x0031)
.equ FM_BLEND_RSSI_MONO_THRESHOLD   = 0x1801 ; Sets RSSI threshold for mono blend (Full mono below threshold, blend above threshold). To force stereo, set this to 0. To force mono, set this to 127. Default value is 30 dBV. (0x001E)

.equ FM_BLEND_RSSI_ATTACK_RATE		= 0x1802
.equ FM_BLEND_RSSI_RELEASE_RATE		= 0x1803
.equ FM_BLEND_SNR_STEREO_THRESHOLD  = 0x1804
.equ FM_BLEND_SNR_MONO_THRESHOLD	= 0x1805
.equ FM_BLEND_SNR_ATTACK_RATE		= 0x1806
.equ FM_BLEND_SNR_RELEASE_RATE		= 0x1807
.equ FM_BLEND_MULTIPATH_STEREO_THRESHOLD= 0x1808

.equ AM_DEEMPHASIS 					= 0x3100 ; Sets de-emphasis time constant. Can be set to 50 us. Deemphasis is disabled by default. 0x0000
.equ AM_CHANNEL_FILTER				= 0x3102 ; Selects the bandwidth of the channel filter for AM/SW/LW reception. The choices are 6, 4, 3, 2, or 1 (kHz). The default bandwidth is 2 kHz. 0x0003
.equ AM_RSQ_INTERRUPTS				= 0x3200 ; Configures interrupt related to RSQ metrics. All interrupts are disabled by default. 0x0000
.equ AM_RSQ_SNR_HIGH_THRESHOLD		= 0x3201 ; Sets high threshold for SNR interrupt. The default is 0 dB. 0x007F
.equ AM_RSQ_SNR_LOW_THRESHOLD		= 0x3202 ; Sets low threshold for SNR interrupt. The default is 0 dB. 0x0000	
.equ AM_RSQ_RSSI_HIGH_THRESHOLD		= 0x3203 ; Sets high threshold for RSSI interrupt. The default is 0 dB. 0x007F
.equ AM_RSQ_RSSI_LOW_THRESHOLD		= 0x3204 ; Sets low threshold for RSSI interrupt. The default is 0 dB. 0x0000	
.equ AM_SOFT_MUTE_RATE				= 0x3300 ; Sets the rate of attack when entering or leaving soft mute. The default is 278 dB/s. 0x0040
.equ AM_SOFT_MUTE_SLOPE				= 0x3301 ; Sets the AM/SW/LW soft mute slope. The bigger the number, the higher the max attenuation level. Default value is a slope of 2.0x0002
.equ AM_SOFT_MUTE_MAX_ATTENUATION	= 0x3302 ; Sets maximum attenuation during soft mute (dB). Set to 0 to disable soft mute. Default is 16 dB. 0x0010 
.equ AM_SOFT_MUTE_SNR_THRESHOLD		= 0x3303 ; Sets SNR threshold to engage soft mute. Default is 10 dB. 0x000A		
.equ AM_SEEK_BAND_BOTTOM			= 0x3400 ; Sets the bottom of the AM/SW/LW band for seek. Default is 520. 0x0208	
.equ AM_SEEK_BAND_TOP				= 0x3401 ; Sets the top of the AM/SW/LW band for seek. Default is 1720. 0x06AE	
.equ AM_SEEK_FREQ_SPACING			= 0x3402 ; Selects frequency spacing for AM/SW/LW seek. Default is 10 kHz spacing. 0x000A
.equ AM_SEEK_SNR_THRESHOLD			= 0x3403 ; Sets the SNR threshold for a valid AM/SW/LW Seek/Tune. If the value is zero then SNR threshold is not considered when doing a seek. Default value is 5 dB. 0x0005
.equ AM_SEEK_RSSI_THRESHOLD			= 0x3404 ; Sets the RSSI threshold for a valid AM/SW/LW Seek/Tune. If the value is zero then RSSI threshold is not considered when doing a seek. Default value is 25 dBuV.0x0019
.equ RX_VOLUME						= 0x4000 ; Sets the output volume. 0x003F										
.equ RX_HARD_MUTE					= 0x4001 ; Mutes the audio output. L and R audio outputs may be muted independently in FM mode. 0x0000


; REGISTER										


.def FEHLER_CODE_TWI 	= R6

.def NULL 				= R12
.def EINS 				= R14
.def VOLL				= R15

.def temp 				= R16
.def temp1 				= R17
.def temp2 				= R18
.def temp3 				= R19
.def temp4 				= R20
.def temp5 				= R21
.def temp6 				= R22
.def temp7 				= R23
.def temp8 				= R24
.def temp9 				= R25

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START+0	; 0x0060 START Adresse (ATmega8)	
.equ adr_ERROR_CODE					=SRAM_START+1	; ERROR-CODE						
.equ adr_TASTENSPERRE_AKTIV			=SRAM_START+2	; TASTENSPERRE (Sender speichern)	
.equ adr_PROGRAMMIERMODUS_AKTIV		=SRAM_START+3	; 1=Programmiermodus				
.equ adr_TASTE						=SRAM_START+4	; TASTE								
.equ adr_MENUE						=SRAM_START+5	; MENUE								
.equ adr_MODUS_AM_FM				=SRAM_START+6	; LW=1 MW=2 KW=3 UKW=4				




.equ adr_VOLUME_IST					=SRAM_START+10 	; Lautstrke						
.equ adr_VOLUME_NORMAL				=SRAM_START+11 	; Lautstrke						
.equ adr_VOLUME_TA					=SRAM_START+12 	; Lautstrke						

.equ adr_FREQUENZ_AM_FM_L			=SRAM_START+20 	; Frequenz LOW	
.equ adr_FREQUENZ_AM_FM_H			=SRAM_START+21 	; Frequenz HIGH	

.equ adr_EINGABE_ZAHL_BYTE0			=SRAM_START+30	; Zahlenfeld	
.equ adr_EINGABE_ZAHL_BYTE1			=SRAM_START+31
.equ adr_EINGABE_ZAHL_BYTE2			=SRAM_START+32
.equ adr_EINGABE_ZAHL_BYTE3			=SRAM_START+33

.equ adr_STATUS						=SRAM_START+40	; SI4753 STATUS					
.equ adr_PILOT						=SRAM_START+41 	; Pilot Indicator 0=Mono 1=Stereo					
.equ adr_STBLEND					=SRAM_START+42  ; Stereo Blend Indicator. Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).
.equ adr_RSSI   					=SRAM_START+43 	; Received Signal Strength Indicator. Contains the current receive signal strength (0127 dBV).				
.equ adr_SNR    					=SRAM_START+44	; SNR. Contains the current SNR metric (0127 dB).	
.equ adr_MULT						=SRAM_START+45	; Multipath						

.equ adr_RDS_BLOCK_AH				=SRAM_START+60	; RDS BLOCK-A		
.equ adr_RDS_BLOCK_AL				=SRAM_START+61
.equ adr_RDS_BLOCK_BH				=SRAM_START+62	; RDS BLOCK-B		
.equ adr_RDS_BLOCK_BL				=SRAM_START+63
.equ adr_RDS_BLOCK_CH				=SRAM_START+64	; RDS BLOCK-C		
.equ adr_RDS_BLOCK_CL				=SRAM_START+65
.equ adr_RDS_BLOCK_DH				=SRAM_START+66	; RDS BLOCK-D		
.equ adr_RDS_BLOCK_DL				=SRAM_START+67

.equ adr_RDS_FIFO					=SRAM_START+70
.equ adr_RDS_PI_L					=SRAM_START+71	; PI										
.equ adr_RDS_PI_H					=SRAM_START+72	; PI										
.equ adr_RDS_GT						=SRAM_START+73	; Gruppentyp								
.equ adr_RDS_PTY					=SRAM_START+74 	; PTY										
.equ adr_RDS_TP						=SRAM_START+75	; Traffic Programm 		(Verkehsfunk)		
.equ adr_RDS_TA						=SRAM_START+76 	; Traffic Announcement 	(Verkehrsdurchsage)	
.equ adr_RDS_MS						=SRAM_START+77 	; Musik / Sprache	(0=Sprache 1=Musik)		
.equ adr_RDS_ERROR					=SRAM_START+78	; RDS-Error									
.equ adr_RDS_ZEIT_HH				=SRAM_START+79	; RDS-ZEIT									
.equ adr_RDS_ZEIT_MM				=SRAM_START+80 	; RDS-ZEIT									
.equ adr_RDS_ZEIT_OFFSET			=SRAM_START+81 	; RDS-ZEIT (Offset)							
.equ adr_RDS_AF_ZEIGER				=SRAM_START+82 	; Zeiger fr AF Darstellung					

.equ adr_RDS_BEREICH_SENDERNAME8	=SRAM_START+90	;   8 Bytes fr Sendername					

.equ adr_SENDERNAME_FREQUENZ_TEXT8	=SRAM_START+100	; 	8 BYTES	fr Sendername oder Frequenz	

.equ adr_RDS_BEREICH_GT32			=SRAM_START+120	;  32 Bytes	fr empfangene Gruppennummern	

.equ adr_RDS_BEREICH_RADIOTEXT128	=SRAM_START+200	; 128 Bytes	fr Radiotext					

.equ adr_RDS_BEREICH_AF205			=SRAM_START+350	; 205 Bytes fr Alternativfrequenzen (0=87,5...204=107,9)	

.equ adr_GRAFIC_PUFFER_TX_ZEIGER	=SRAM_START+800	; Zeiger Puffer						
.equ adr_GRAFIC_PUFFER256			=SRAM_START+801	; Puffer							

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; EEPROM-BELEGUNG ATmega8						
.equ adr_EEPROM_WERKSEINSTELLUNG			= 0
.equ adr_EEPROM_TASTEN						= 10


.cseg					;Beginn eines Code-Segmentes							
.org 0					;Startadresse=0											

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp				
; LED-INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; PWM-INITIALISIERUNG								
	rcall PWM_INITIALISIERUNG
; TWI_INI											
	rcall TWI_INI
; RS232_INITIALISIEREN								
	rcall RS232_INITIALISIEREN
; PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; Interrupts freigeben								
	sei
;-------------------------------------------------------------------------------
	rcall GRAFIC_INITIALISIERUNG
	rcall ANZEIGE_BEGRUESSUNG
	rcall EEPROM_WERKSEINSTELLUNG
	rcall GRAFIC_BEEP
	rcall GRAFIC_BEEP
	rcall GRAFIC_BEEP
	rcall SI4735_POWER_UP_FM
	; SENDER							
	ldi temp,40
	STS(adr_TASTE),temp
	rcall TASTE_40_SENDERSPEICHER_LOAD
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall TASTEN_ABFRAGEN
	LDS temp,(adr_TASTE)
	tst temp
	brne LOOP_MENUE
;-------------------------------------------------------------------------------
	LDS temp,(adr_MODUS_AM_FM)
	cpi temp,(MODUS_UKW)
	brne LOOP_AM
	rcall SI4735_FM_TUNE_STATUS
	rcall SI4735_FM_RSQ_STATUS
	rcall SI4735_FM_RDS_STATUS
	rjmp LOOP_MENUE
;-------------------------------------------------------------------------------
LOOP_AM:
	rcall SI4735_AM_TUNE_STATUS
	rcall SI4735_AM_RSQ_STATUS
;-------------------------------------------------------------------------------
LOOP_MENUE:
	rcall ANZEIGE_PWM_ANALOGINSTRUMENT
	rcall MENUE
	rcall SI4735_LAUTSTAERKE_TA
	rcall ANZEIGE_ERROR
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "RADIO_GRAFIC_MENUE.asm"
.include "RADIO_GRAFIC_ini.asm"
.include "RADIO_GRAFIC_PAKET.asm"
.include "RADIO_GRAFIC_ZAHLEN.asm"
.include "RADIO_GRAFIC_ANZEIGE.asm"
.include "RADIO_GRAFIC_ANZEIGE_KURZ.asm"
.include "RADIO_GRAFIC_TASTEN.asm"
.include "RADIO_SI4735_ALLG.asm"
.include "RADIO_SI4735_FM.asm"
.include "RADIO_SI4735_RDS.asm"
.include "RADIO_SI4735_AM.asm"
.include "RADIO_SONSTIGES.asm"			; sonstiges						
.include "RADIO_TWI.asm"
.include "RADIO_EEPROM.asm"
.include "RADIO_WAIT_01MHZ.asm"		;  1 MHz						
;.include "RADIO_WAIT_08MHZ.asm"		;  8 MHz						
;.include "RADIO_WAIT_16MHZ.asm"		; 16 MHz						

TEXT_BEGRUESSUNG_1:
.db "RADIO RDS",0
TEXT_BEGRUESSUNG_2:
.db "SI4735 ",0
TEXT_BEGRUESSUNG_3:
.db "ATmega8 - 1MHz ",0
TEXT_BEGRUESSUNG_4:
.db "08/2013",0
TEXT_BEGRUESSUNG_5:
.db "Bernhard.Erfurt@gmx.de",0

; TASTEN											
TASTE_02_AUS:
.db    0, 0,30,16,2,'a','u','s',0	;02 aus		
TASTE_01_RESET:
.db    0,40,30,16,1,'R','e','s',0	;01 RESET	
TASTE_03_LW_ON:
.db    30,0,30,16,3,'L','W',0		;03 LW-ON	
TASTE_04_MW_ON:
.db    60,0,30,16,4,'M','W',0		;04 MW-ON	
TASTE_05_KW_ON:
.db    90,0,30,16,5,'K','W',0		;05 KW-ON	
TASTE_06_UKW_ON:
.db   120,0,30,16,6,'U','K','W',0	;06 UKW-ON	
TASTE_08_TASTENSPERRE:
.db   60,40,30,16,8,'P','r','o',0	;08 Tastensperre aufheben (Programmiermodus)
TASTE_10_HAUPTMENUE:
.db   120,0,40,60,10,'M',0			;10 (versteckt)		
TASTE_11_HELLIGKEIT:
.db   30,40,30,16,11,'H','e','L',0	;11 Helligkeit
TASTE_12_LAUTSTAERKE_PLUS:
.db  140,88,20,16,12,'+',0			;12 LAUTSTAERKE
TASTE_13_LAUTSTAERKE_MINUS:
.db    0,88,20,16,13,'-',0			;13 LAUTSTAERKE
TASTE_14_SENDER_SEEK_DOWN:
.db   30,88,20,16,14,'<','<',0		;14 SENDER <<		
TASTE_15_SENDER_STEP_DOWN:
.db   50,88,20,16,15,'<',0			;15 SENDER <		
TASTE_16_SENDER_SEEK_UP:
.db  110,88,20,16,16,'>','>',0		;16 SENDER >>		
TASTE_17_SENDER_STEP_UP:
.db   90,88,20,16,17,'>',0			;17 SENDER >		
TASTE_18_SENDER_MANUELL:
.db   70,88,20,16,18,'m',0			;18 SENDER (manuell)
TASTE_20_DISPLAY_AM_FM:
.db   120,80,30,16,20,'D','i','p',0	;20 DISPLAY AM/FM	
TASTE_21_INFO_AM_FM:
.db     0,80,30,16,21,'I','N','F',0	;21 AM/FM-INFO		
TASTE_24_FM_SCAN:	
.db   90,80,30,16,24,'S','c','n',0	;24 FM-SCAN			
TASTE_28_AF:
.db   30,80,30,16,28,'A','F',0		;28 FM-AF			
TASTE_29_GT:
.db   60,80,30,16,29,'G','T',0		;29 FM-RDS-GT		
TASTE_39_SENDERLOAD:
.db     0,0,40,60,39,'L',0			;39 (versteckt)		
TASTE_51_SENDERSAVE:
.db    60,0,40,60,51,'S',0			;51 (versteckt)		



; ZAHLENFELD	
TASTE_100_ZAHL_0:	
.db  60,70,30,16, 100, '0',0			;100 "0"
TASTE_101_ZAHL_1:	
.db  30,10,30,16, 101,'1',0				;101 "1"
TASTE_102_ZAHL_2:
.db  60,10,30,16, 102,'2',0				;102 "2"
TASTE_103_ZAHL_3:	
.db  90,10,30,16, 103,'3',0				;103 "3"
TASTE_104_ZAHL_4:	
.db  30,30,30,16, 104,'4',0				;104 "4"
TASTE_105_ZAHL_5:
.db  60,30,30,16, 105,'5',0				;105 "5"
TASTE_106_ZAHL_6:	
.db  90,30,30,16, 106,'6',0				;106 "6"
TASTE_107_ZAHL_7:	
.db  30,50,30,16, 107, '7',0			;107 "7"
TASTE_108_ZAHL_8:	
.db  60,50,30,16, 108, '8',0			;108 "8"
TASTE_109_ZAHL_9:	
.db  90,50,30,16, 109, '9',0			;109 "9"
TASTE_111_ZAHL_OK:
.db 120,90,30,16, 111,  'O','K',0		;111 "OK"	
TASTE_112_ZAHL_ESC:
.db 0, 90,30,16, 112,  'E','s','c',0	;112 "ESC"	


TEXT_PTY_00: 
.db "kein PTY",0
TEXT_PTY_01: 
.db "Nachrichten",0 
TEXT_PTY_02: 
.db "Aktuelles",0 
TEXT_PTY_03: 
.db "Information",0 
TEXT_PTY_04: 
.db "Sport",0 
TEXT_PTY_05: 
.db "Bildung",0 
TEXT_PTY_06: 
.db "Hrspiel",0 
TEXT_PTY_07: 
.db "Kultur",0 
TEXT_PTY_08: 
.db "Wissenschaft",0 
TEXT_PTY_09: 
.db "Unterhaltung (Wort)",0 
TEXT_PTY_10: 
.db "Popmusik",0
TEXT_PTY_11: 
.db "Rockmusik",0 
TEXT_PTY_12: 
.db "Unterhaltungsmusik",0 
TEXT_PTY_13: 
.db "Leichte Klassik",0 
TEXT_PTY_14: 
.db "Ernste Klassik",0 
TEXT_PTY_15: 
.db "Andere Musik",0 
TEXT_PTY_16: 
.db "Wetter",0
TEXT_PTY_17: 
.db "Finanzen",0
TEXT_PTY_18: 
.db "Kinderprogramm",0
TEXT_PTY_19: 
.db "Gesellschaftliches",0
TEXT_PTY_20: 
.db "Religion",0
TEXT_PTY_21: 
.db "Telefonieren",0
TEXT_PTY_22: 
.db "Reisen",0
TEXT_PTY_23: 
.db "Freizeit",0
TEXT_PTY_24: 
.db "Jazzmusik",0
TEXT_PTY_25: 
.db "Countrymusik",0
TEXT_PTY_26: 
.db "Nationale Musik",0
TEXT_PTY_27: 
.db "Oldies",0
TEXT_PTY_28: 
.db "Volksmusik",0
TEXT_PTY_29: 
.db "Dokumentationen",0
TEXT_PTY_30: 
.db "Testalarm",0
TEXT_PTY_31: 
.db "Alarm",0



